Sub convert()
    ' This will convert a csv file 'name.csv' in a text file 'name.txt'


    ' Select a CSV file
    With Application.FileDialog(msoFileDialogFilePicker)
        .Title = "Select CSV file"
        .InitialFileName = ActiveWorkbook.Path
        .Filters.Add "CSV file", "*.csv", 1
        If .Show = -1 Then
            mypath = .SelectedItems(1)
        Else                                            ' Pressed Cancel =>
            Exit Sub                                    ' leave Macro
        End If
    End With

    Workbooks.Open (mypath)                             ' Open selected file

    Set iWS = ActiveWorkbook.Worksheets(1)              ' Make sure to use the correct worksheet
    ActiveWorkbook.Worksheets.Add after:=iWS            ' Create a new sheet to store the converted data
    Set nWS = ActiveWorkbook.Worksheets(2)
    nRow = 1
    For iRow = 1 To iWS.UsedRange.Rows.Count
        line1 = "long s" & iWS.Cells(iRow, 2).Value     ' Slave + relays 33-49
        line2 = ""                                      ' relays 1-32
        line3 = iWS.Cells(iRow, 1).Value * 1000         ' time
        For iColumn = 3 To iWS.UsedRange.Columns.Count
            c = iWS.Cells(iRow, iColumn).Value          ' empty cell is indicated with 0, so check for that
            If c > 0 And c < 33 Then                    ' Relays 1-32 belong in line2
                line2 = line2 & " + ry" & c
            ElseIf c > 32 And c < 50 Then               ' Relays 33-49 in line1
                line1 = line1 & " + ry" & c
            End If
        Next iColumn
        If line2 = "" Then
            line2 = "long 0"                            ' No relays in group2
        Else
            line2 = "long " & Mid(line2, 2)             ' Remove first '+'
        End If
        nWS.Cells(nRow, 1).Value = line1
        nWS.Cells(nRow + 1, 1).Value = line2
        nRow = nRow + 2
        ' Look ahead to see if same time value is used for next slave
        If iWS.Cells(iRow + 1, 1).Value <> iWS.Cells(iRow, 1).Value Then
            nWS.Cells(nRow, 1).Value = "long at + " & line3
            nRow = nRow + 1
        End If
    Next iRow

    Application.DisplayAlerts = False                   ' Turn off the confirmation dialogue
    iWS.Delete                                          ' remove csv data
    Application.DisplayAlerts = True                    ' And on again
    nFile = Left(mypath, InStrRev(mypath, ".")) & "txt"

    ActiveWorkbook.SaveAs Filename:=nFile, FileFormat:=-4158     ' save as text file
    ActiveWorkbook.Close SaveChanges:=False
End Sub
